\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ for i in *; do (cd $i; for j in *.tex; do if [ -e "$j" ]; then gp-inline $j; fi done); done


default(recover,0);
read("../geom.gp");
read("../geom-inertia.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     \\quit(1)
     ,
     print("ok "check_count" "name));
}

matrix_sum(m)=vecsum(sum(i=1,matsize(m)[2],m[,i]));

nearly_equal_epsilon = 1e-15;
nearly_equal(x,y, epsilon=nearly_equal_epsilon) = {
  x=abs(x-y);
  if(type(x)=="t_VEC" || type(x)=="t_COL",x=vecsum(x));
  if(type(x)=="t_MAT",x=matrix_sum(x));
  if(type(x)=="t_QUAD" || type(x)=="t_COMPLEX",x=real(x)+imag(x));
  x < epsilon;
}
check_nearly(got,want,name="") =
{
  check_count++;
  if(! nearly_equal(got,want),
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}


\\-----------------------------------------------------------------------------

w=quadgen(-3);
check_exact(w^3,1);

g=1/(1-w*x)
real(g)
imag(g)
real(g) + w*imag(g)
check_exact((g-real(g))/imag(g), w);
w.disc